/*

 SPC 10-1F Commands

*/

/* 10 */

SPC_BPL:
    movw %bx,PC
    SPC_ADDR_IM
    TEST_FLAG_SPC(SPC_FLAG_N)
    jnz SPC_BACK        // condition true
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK

/* 11 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_1:
    TCALL 1
    jmp SPC_BACK

/* 12 */

SPC_CLR0:
    SPC_CLR 0
    jmp SPC_BACK

/* 13 */

SPC_BBC0:
    SPC_BBC 0
    jmp SPC_BACK

/* 14 */

SPC_OR_A_Odp_XO:
    SPC_OR_A Odp_XO
    jmp SPC_BACK

/* 15 */

SPC_OR_A_Oabs_XO:
    SPC_OR_A OABS_XO
    jmp SPC_BACK

/* 16 */

SPC_OR_A_Oabs_YO:
    SPC_OR_A OABS_YO
    jmp SPC_BACK

/* 17 */

SPC_OR_A_OOdpO_YO:
    SPC_OR_A OOdpO_YO
    jmp SPC_BACK

/* 18 */

SPC_OR_dp_IM:
    SPC_ADDR_dp_IM      // %dl contains immediate, %bx dest address
    GET_BYTE_SPC        // get (dp)
    orb %dl,%al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
    jmp SPC_BACK

/* 19 */

SPC_OR_OXO_OYO:
    SPC_ADDR_OXO_OYO    // %dl contains (Y), %bx dest address
    GET_BYTE_SPC        // get (X)
    orb %dl,%al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
    jmp SPC_BACK

/* 1A */

SPC_DECW_dp:
    SPC_ADDR_dp
    GET_WORD_SPC            // get DP word
    movl %eax,%edx
    decw %dx
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    decw %bx
    movl %edx,%eax
    SET_WORD_SPC
    jmp SPC_BACK

/* 1B */

SPC_ASL_Odp_XO:
    SPC_ASL Odp_XO
    jmp SPC_BACK

/* 1C */

SPC_ASL_A:
    movw %bx,PC
    shlb $1,A
    STORE_FLAGS_SPC (SPC_MASK_C+SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* 1D */

SPC_DEC_X:
    movw %bx,PC
    decb X
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* 1E */

SPC_CMP_X_abs:
    SPC_CMP_X ABS
    jmp SPC_BACK

/* 1F */

SPC_JMP_Oabs_XO:
    SPC_ADDR_OABS_XO
    xorl %eax,%eax
    GET_WORD_SPC
    movl %eax,PC
    jmp SPC_BACK
