/*

 SPC 20-2F Commands

*/

/* 20 */

SPC_CLRP:
    movw %bx,PC
    CLR_FLAG_SPC(SPC_FLAG_P)
    movb $0,SPC_PAGE+1
    jmp SPC_BACK

/* 21 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_2:
    TCALL 2
    jmp SPC_BACK

/* 22 */

SPC_SET1:
    SPC_SET 1
    jmp SPC_BACK

/* 23 */

SPC_BBS1:
    SPC_BBS 1
    jmp SPC_BACK

/* 24 */

SPC_AND_A_dp:
    SPC_AND_A dp
    jmp SPC_BACK

/* 25 */

SPC_AND_A_abs:
    SPC_AND_A ABS
    jmp SPC_BACK

/* 26 */

SPC_AND_A_OXO:
    SPC_AND_A OXO
    jmp SPC_BACK

/* 27 */

SPC_AND_A_OOdp_XOO:
    SPC_AND_A OOdp_XOO
    jmp SPC_BACK

/* 28 */

SPC_AND_A_IM:
    movw %bx,PC
    SPC_AND_A IM
    jmp SPC_BACK

/* 29 */

SPC_AND_dp_dp:
    SPC_ADDR_dp_dp      // %dl is (s), %bx is d
    GET_BYTE_SPC        // get (d)
    andb %dl,%al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
    jmp SPC_BACK

/* 2A */

SPC_OR1C:       // Carry flag = Carry flag OR !mem.bit
    SPC_ADDR_membit     // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC        // Get byte at location
    btl %edx,%eax
    jc  SPC_BACK        // C | ~1 = C
    SET_FLAG_SPC (SPC_FLAG_C)   // C | ~0 = 1
    jmp SPC_BACK

/* 2B */

SPC_ROL_dp:
    SPC_ROL dp
    jmp SPC_BACK

/* 2C */

SPC_ROL_abs:
    SPC_ROL ABS
    jmp SPC_BACK

/* 2D */

SPC_PUSH_A:
    movw %bx,PC
    movb A,%al
    PUSH_B
    jmp SPC_BACK

/* 2E */

SPC_CBNE_dp:
    SPC_ADDR_dp
    GET_BYTE_SPC        // Get (dp)
    SPC_ADDR_IM
    cmpb %al,A
    je SPC_BACK
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK

/* 2F */

SPC_BRA:
    movw %bx,PC
    SPC_ADDR_IM
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK
