/*

 SPC 40-4F Commands

*/

/* 40 */

SPC_SETP:
    movw %bx,PC
    SET_FLAG_SPC(SPC_FLAG_P)
    CLR_FLAG_SPC(SPC_FLAG_I)
    movb $1,SPC_PAGE+1
    jmp SPC_BACK

/* 41 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_4:
    TCALL 4
    jmp SPC_BACK

/* 42 */

SPC_SET2:
    SPC_SET 2
    jmp SPC_BACK

/* 43 */

SPC_BBS2:
    SPC_BBS 2
    jmp SPC_BACK

/* 44 */

SPC_EOR_A_dp:
    SPC_EOR_A dp
    jmp SPC_BACK

/* 45 */

SPC_EOR_A_abs:
    SPC_EOR_A ABS
    jmp SPC_BACK

/* 46 */

SPC_EOR_A_OXO:
    SPC_EOR_A OXO
    jmp SPC_BACK

/* 47 */

SPC_EOR_A_OOdp_XOO:
    SPC_EOR_A OOdp_XOO
    jmp SPC_BACK

/* 48 */

SPC_EOR_A_IM:
    movw %bx,PC
    SPC_EOR_A IM
    jmp SPC_BACK

/* 49 */

SPC_EOR_dp_dp:
    SPC_ADDR_dp_dp
    GET_BYTE_SPC
    xorb %dl,%al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
    jmp SPC_BACK

/* 4A */

SPC_AND1:       // Carry flag = Carry flag AND mem.bit
    SPC_ADDR_membit     // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC        // Get byte at location
    btl %edx,%eax
    jc  SPC_BACK        // C & 1 = C
    CLR_FLAG_SPC (SPC_FLAG_C)   // C & 0 = 0
    jmp SPC_BACK

/* 4B */

SPC_LSR_dp:
    SPC_LSR dp
    jmp SPC_BACK

/* 4C */

SPC_LSR_abs:
    SPC_LSR ABS
    jmp SPC_BACK

/* 4D */

SPC_PUSH_X:
    movw %bx,PC
    movb X,%al
    PUSH_B
    jmp SPC_BACK

/* 4E */

SPC_TCLR1:          // I have done this as TRB (65816) including the flag setting based on AND
    SPC_ADDR_ABS
    GET_BYTE_SPC    // Get byte
    movb A,%dl
    testb %al,%dl   // NZ set for: mem & A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    notb %dl
    andb %dl,%al
    SET_BYTE_SPC    // mem &= ~A
    jmp SPC_BACK

/* 4F */

SPC_PCALL:  // u-page is the last page on the SPC RAM (uppermost-page!)
    movl $0xFF00,%eax
    movb 1(%esi),%al    // upage offset
    incl %ebx
    movl %eax,PC
    movl %ebx,%eax
    PUSH_W
    jmp SPC_BACK
