/*

 SPC 80-8F Commands

*/

/* 80 */

SPC_SETC:
    movw %bx,PC
    SET_FLAG_SPC (SPC_FLAG_C)
    jmp SPC_BACK

/* 81 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_8:
    TCALL 8
    jmp SPC_BACK

/* 82 */

SPC_SET4:
    SPC_SET 4
    jmp SPC_BACK

/* 83 */

SPC_BBS4:
    SPC_BBS 4
    jmp SPC_BACK

/* 84 */

SPC_ADC_A_dp:
    SPC_ADC_A dp
    jmp SPC_BACK

/* 85 */

SPC_ADC_A_abs:
    SPC_ADC_A ABS
    jmp SPC_BACK

/* 86 */

SPC_ADC_A_OXO:
    SPC_ADC_A OXO
    jmp SPC_BACK

/* 87 */

SPC_ADC_A_OOdp_XOO:
    SPC_ADC_A OOdp_XOO
    jmp SPC_BACK

/* 88 */

SPC_ADC_A_IM:
    movw %bx,PC
    SPC_ADC_A IM
    jmp SPC_BACK

/* 89 */

SPC_ADC_dp_dp:
    SPC_ADDR_dp_dp
    GET_BYTE_SPC
    pushl %eax
    MAKE_FLAGS_SPC (SPC_MASK_C)
    popl %eax
    adcb %al,%dl
    pushf
    jo 1f
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    jmp 2f
1:	SET_FLAG_SPC(SPC_FLAG_V)
2:	popf
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C+SPC_MASK_H)
    movb %dl,%al
    SET_BYTE_SPC
    jmp SPC_BACK

/* 8A */

SPC_EOR1:       // Carry flag = Carry flag EOR mem.bit
    SPC_ADDR_membit     // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC        // Get byte at location
    btl %edx,%eax
    jnc SPC_BACK        // C = C EOR 0 -> C = C
    CPL_FLAG_SPC (SPC_FLAG_C)   // C = C EOR 1 -> C = !C
    jmp SPC_BACK

/* 8B */

SPC_DEC_dp:
    SPC_DEC dp
    jmp SPC_BACK

/* 8C */

SPC_DEC_abs:
    SPC_DEC ABS
    jmp SPC_BACK

/* 8D */

SPC_MOV_Y_IM:
    movw %bx,PC
    SPC_MOV_Y_ IM
    jmp SPC_BACK

/* 8E */

SPC_POP_PSW:
    movw %bx,PC
    POP_B
    RESTOREFLAGS_SPC
    jmp SPC_BACK

/* 8F */

SPC_MOV_dp_IM:
    SPC_ADDR_dp_IM
    movb %dl,%al
    SET_BYTE_SPC
    jmp SPC_BACK
