/*

 SPC 90-9F Commands

*/

/* 90 */

SPC_BCC:
    movw %bx,PC
    SPC_ADDR_IM
    TEST_FLAG_SPC(SPC_FLAG_C)
    jnz SPC_BACK        // condition true
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK

/* 91 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_9:
    TCALL 9
    jmp SPC_BACK

/* 92 */

SPC_CLR4:
    SPC_CLR 4
    jmp SPC_BACK

/* 93 */

SPC_BBC4:
    SPC_BBC 4
    jmp SPC_BACK

/* 94 */

SPC_ADC_A_Odp_XO:
    SPC_ADC_A Odp_XO
    jmp SPC_BACK

/* 95 */

SPC_ADC_A_Oabs_XO:
    SPC_ADC_A OABS_XO
    jmp SPC_BACK

/* 96 */

SPC_ADC_A_Oabs_YO:
    SPC_ADC_A OABS_YO
    jmp SPC_BACK

/* 97 */

SPC_ADC_A_OOdpO_YO:
    SPC_ADC_A OOdpO_YO
    jmp SPC_BACK

/* 98 */

SPC_ADC_dp_IM:
    SPC_ADDR_dp_IM
    GET_BYTE_SPC
    pushl %eax
    MAKE_FLAGS_SPC (SPC_MASK_C)
    popl %eax
    adcb %al,%dl        // result needs saving to (dp)
    pushf
    jo 1f
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    jmp 2f
1:	SET_FLAG_SPC(SPC_FLAG_V)
2:	popf
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C+SPC_MASK_H)
    movb %dl,%al
    SET_BYTE_SPC        // store in (dp)
    jmp SPC_BACK

/* 99 */

SPC_ADC_OXO_OYO:
    SPC_ADDR_OXO_OYO
    GET_BYTE_SPC
    pushl %eax
    MAKE_FLAGS_SPC (SPC_MASK_C)
    popl %eax
    adcb %al,%dl        // result needs saving to (dp)
    pushf
    jo 1f
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    jmp 2f
1:	SET_FLAG_SPC(SPC_FLAG_V)
2:	popf
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C+SPC_MASK_H)
    movb %dl,%al
    SET_BYTE_SPC        // store in (dp)
    jmp SPC_BACK

/* 9A */

SPC_SUBW_YA_dp:
    SPC_ADDR_dp
    movl YA,%edx
    GET_WORD_SPC        // get DP word
    subw %ax,%dx
    pushf
    jo 1f
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    jmp 2f
1:	SET_FLAG_SPC(SPC_FLAG_V)
2:	popf
    cmc
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C+SPC_MASK_H)
    movl %edx,YA
    jmp SPC_BACK

/* 9B */

SPC_DEC_Odp_XO:
    SPC_DEC Odp_XO
    jmp SPC_BACK

/* 9C */

SPC_DEC_A:
    movw %bx,PC
    decb A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* 9D */

SPC_MOV_X_SP:
    movw %bx,PC
    movb SP,%al
    testb %al,%al
    movb %al,X
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* 9E */

SPC_DIV:                // This may not be 100% due to overflow checking!
    movw %bx,PC
    xorl %ebx,%ebx
    movb X,%bl
    testb %bl,%bl       // If zero skip divide!
    jz SPC_DIV_OVERFLOW
    movl YA,%eax       // Dividend
    xorl %edx,%edx
    divw %bx            // Result is ax=quotient,dx=remainder
    testb %ah,%ah       // Check for overflow
    jnz SPC_DIV_OVERFLOW    // (0.33) Butcha - fixed stack corruption
SPC_DIV_NO_OVERFLOW:
    movb %al,A         // Quotient in A
    movb %dl,Y         // Remainder in Y
    CLR_FLAG_SPC (SPC_FLAG_V)
    testb %al,%al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK
.balign 16
SPC_DIV_OVERFLOW:
    SET_FLAG_SPC (SPC_FLAG_V+SPC_FLAG_N)
    CLR_FLAG_SPC (SPC_FLAG_Z)
    movl $0xFFFF,YA
    jmp SPC_BACK

/* 9F */

SPC_XCN:
    movw %bx,PC
    movb A,%al
    rolb $4,%al
    testb %al,%al
    movb %al,A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK
