/*

 SPC A0-AF Commands

*/

/* A0 */

SPC_EI:
    movw %bx,PC
    SET_FLAG_SPC(SPC_FLAG_I)
    jmp SPC_BACK

/* A1 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_10:
    TCALL 10
    jmp SPC_BACK

/* A2 */

SPC_SET5:
    SPC_SET 5
    jmp SPC_BACK

/* A3 */

SPC_BBS5:
    SPC_BBS 5
    jmp SPC_BACK

/* A4 */

SPC_SBC_A_dp:
    SPC_SBC_A dp
    jmp SPC_BACK

/* A5 */

SPC_SBC_A_abs:
    SPC_SBC_A ABS
    jmp SPC_BACK

/* A6 */

SPC_SBC_A_OXO:
    SPC_SBC_A OXO
    jmp SPC_BACK

/* A7 */

SPC_SBC_A_OOdp_XOO:
    SPC_SBC_A OOdp_XOO
    jmp SPC_BACK

/* A8 */

SPC_SBC_A_IM:
    movw %bx,PC
    SPC_SBC_A IM
    jmp SPC_BACK

/* A9 */

SPC_SBC_dp_dp:
    SPC_ADDR_dp_dp
    GET_BYTE_SPC
    pushl %eax
    MAKE_FLAGS_SPC_INV (SPC_MASK_C)
    popl %eax
    sbbb %dl,%al        // (0.30) Butcha - switched these, wrong order
    pushf
    jo 1f
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    jmp 2f
1:	SET_FLAG_SPC(SPC_FLAG_V)
2:	popf
    cmc
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C+SPC_MASK_H)
    SET_BYTE_SPC
    jmp SPC_BACK

/* AA */

SPC_MOV1_C_:        // Carry flag = mem.bit
    SPC_ADDR_membit     // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC        // Get byte at location
    btl %edx,%eax
    jnc 0f
    SET_FLAG_SPC (SPC_FLAG_C)
    jmp SPC_BACK
0:	CLR_FLAG_SPC (SPC_FLAG_C)
    jmp SPC_BACK

/* AB */

SPC_INC_dp:
    SPC_INC dp
    jmp SPC_BACK

/* AC */

SPC_INC_abs:
    SPC_INC ABS
    jmp SPC_BACK

/* AD */

SPC_CMP_Y_IM:
    movw %bx,PC
    SPC_CMP_Y IM
    jmp SPC_BACK

/* AE */

SPC_POP_A:
    movw %bx,PC
    POP_B
    movb %al,A
    jmp SPC_BACK

/* AF */

SPC_MOV_OXOInc_A:
    SPC_ADDR_OXOInc
    movb A,%al
    SET_BYTE_SPC
    jmp SPC_BACK
