/*

 SPC B0-BF Commands

*/

/* B0 */

SPC_BCS:
    movw %bx,PC
    SPC_ADDR_IM
    TEST_FLAG_SPC(SPC_FLAG_C)
    jz  SPC_BACK        // condition false
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK

/* B1 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_11:
    TCALL 11
    jmp SPC_BACK

/* B2 */

SPC_CLR5:
    SPC_CLR 5
    jmp SPC_BACK

/* B3 */

SPC_BBC5:
    SPC_BBC 5
    jmp SPC_BACK

/* B4 */

SPC_SBC_A_Odp_XO:
    SPC_SBC_A Odp_XO
    jmp SPC_BACK

/* B5 */

SPC_SBC_A_Oabs_XO:
    SPC_SBC_A OABS_XO
    jmp SPC_BACK

/* B6 */

SPC_SBC_A_Oabs_YO:
    SPC_SBC_A OABS_YO
    jmp SPC_BACK

/* B7 */

SPC_SBC_A_OOdpO_YO:
    SPC_SBC_A OOdpO_YO
    jmp SPC_BACK

/* B8 */

SPC_SBC_dp_IM:
    SPC_ADDR_dp_IM
    GET_BYTE_SPC
    pushl %eax
    MAKE_FLAGS_SPC_INV (SPC_MASK_C)
    popl %eax
    sbbb %dl,%al            // (0.30) Butcha - switched these, wrong order
    pushf
    jo 1f
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    jmp 2f
1:	SET_FLAG_SPC(SPC_FLAG_V)
2:	popf
    cmc
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C+SPC_MASK_H)
    SET_BYTE_SPC
    jmp SPC_BACK

/* B9 */

SPC_SBC_OXO_OYO:
    SPC_ADDR_OXO_OYO
    GET_BYTE_SPC
    pushl %eax
    MAKE_FLAGS_SPC_INV (SPC_MASK_C)
    popl %eax
    sbbb %dl,%al            // (0.30) Butcha - switched these, wrong order
    pushf
    jo 1f
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    jmp 2f
1:	SET_FLAG_SPC(SPC_FLAG_V)
2:	popf
    cmc
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C+SPC_MASK_H)
    SET_BYTE_SPC
    jmp SPC_BACK

/* BA */

SPC_MOV_YA_dp:
    SPC_ADDR_dp
    xorl %eax,%eax
    GET_WORD_SPC
    testw %ax,%ax
    movl %eax,YA
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* BB */

SPC_INC_Odp_XO:
    SPC_INC Odp_XO
    jmp SPC_BACK

/* BC */

SPC_INC_A:
    movw %bx,PC
    incb A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* BD */

SPC_MOV_SP_X:
    movb X,%al
    movw %bx,PC
    movb %al,SP
    jmp SPC_BACK

/* BE */

/* DAS - not yet implemented */

/* BF */

SPC_MOV_A_OXOInc:
    SPC_ADDR_OXOInc
    GET_BYTE_SPC
    testb %al,%al
    movb %al,A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK
