/*

 SPC F0-FF Commands

*/

/* F0 */

SPC_BEQ:
    movw %bx,PC
    SPC_ADDR_IM
    TEST_FLAG_SPC(SPC_FLAG_Z)
    jz  SPC_BACK        // condition false
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK

/* F1 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_15:
    TCALL 15
    jmp SPC_BACK

/* F2 */

SPC_CLR7:
    SPC_CLR 7
    jmp SPC_BACK

/* F3 */

SPC_BBC7:
    SPC_BBC 7
    jmp SPC_BACK

/* F4 */

SPC_MOV_A_Odp_XO:
    SPC_MOV_A_ Odp_XO
    jmp SPC_BACK

/* F5 */

SPC_MOV_A_Oabs_XO:
    SPC_MOV_A_ OABS_XO
    jmp SPC_BACK

/* F6 */

SPC_MOV_A_Oabs_YO:
    SPC_MOV_A_ OABS_YO
    jmp SPC_BACK

/* F7 */

SPC_MOV_A_OOdpO_YO:
    SPC_MOV_A_ OOdpO_YO
    jmp SPC_BACK

/* F8 */

SPC_MOV_X_dp:
    SPC_MOV_X_ dp
    jmp SPC_BACK

/* F9 */

SPC_MOV_X_Odp_YO:
    SPC_MOV_X_ Odp_YO
    jmp SPC_BACK

/* FA */

SPC_MOV_dp_dp:
    SPC_ADDR_dp_dp      // %dl is (s), %bx d
    movb %dl,%al
    SET_BYTE_SPC
    jmp SPC_BACK

/* FB */

SPC_MOV_Y_Odp_XO:
    SPC_MOV_Y_ Odp_XO
    jmp SPC_BACK

/* FC */

SPC_INC_Y:
    movw %bx,PC
    incb Y
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* FD */

SPC_MOV_Y_A:
    movw %bx,PC
    movb A,%al
    testb %al,%al
    movb %al,Y
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* FE */

SPC_DBNZ_Y:
    movw %bx,PC
    SPC_ADDR_IM
    decb Y
    jz SPC_BACK
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK

/* FF */

SPC_STOP:
    movw %bx,PC
    decw PC
    jmp SPC_BACK        // What else can stop do?
