/*

    SPC Addressing mode stuff - because the SPC looks a nitemare without it!

        Code By Savoury SnaX - yup another macro based chunk

   ALL macros setup %ebx.

*/

.macro SPC_ADDR_IM
    movl PC,%ebx
    incw PC
.endm

.macro SPC_ADDR_dp
    incl %ebx
    movw %bx,PC
    movl SPC_PAGE,%ebx
    movb 1(%esi),%bl    // get dp
.endm

.macro SPC_ADDR_Odp_XO
    incl %ebx
    movw %bx,PC
    movl SPC_PAGE,%ebx
    movb X,%dl
    movb 1(%esi),%bl    // get dp
    addb %dl,%bl
.endm

.macro SPC_ADDR_Odp_YO
    incl %ebx
    movw %bx,PC
    movl SPC_PAGE,%ebx
    movb Y,%dl
    movb 1(%esi),%bl    // get dp
    addb %dl,%bl
.endm

.macro SPC_ADDR_OOdp_XOO
    SPC_ADDR_Odp_XO
    GET_WORD_SPC
    movl %eax,%ebx
.endm

.macro SPC_ADDR_OOdpO_YO
    SPC_ADDR_dp
    GET_WORD_SPC
    xorl %edx,%edx
    movl %eax,%ebx
    movb Y,%dl
    addw %dx,%bx
.endm

.macro SPC_ADDR_OXO
    movl SPC_PAGE,%eax
    movw %bx,PC
    movb X,%al
    movl %eax,%ebx
.endm

.macro SPC_ADDR_OYO
    movl SPC_PAGE,%eax
    movw %bx,PC
    movb Y,%al
    movl %eax,%ebx
.endm

.macro SPC_ADDR_dp_dp   /* Special one, %dl contains source byte %bx dest address */
    addl $2,%ebx
    movl SPC_PAGE,%eax
    movw %bx,PC
    movb 1(%esi),%al    // get src dp
    movl %eax,%ebx
    GET_BYTE_SPC
    movb %al,%dl        // source byte in %dl
    movb 2(%esi),%bl    // get dest dp
.endm

.macro SPC_ADDR_dp_IM   /* Special one, %dl contains IM byte %bx dest address */
    addl $2,%ebx
    movl SPC_PAGE,%eax
    movw %bx,PC
    movb 1(%esi),%dl    // immediate byte in %dl
    movb 2(%esi),%al    // get dp
    movl %eax,%ebx
.endm

.macro SPC_ADDR_OXO_OYO /* Special one, %dl contains (Y) %bx dest address */
    movl SPC_PAGE,%eax
    movw %bx,PC
    movb Y,%al
    movl %eax,%ebx
    GET_BYTE_SPC
    movb %al,%dl
    movb X,%bl
.endm

.macro SPC_ADDR_OXOInc
    movl SPC_PAGE,%eax  // Get Page Variable!
    movw %bx,PC
    movb X,%al
    movl %eax,%ebx
    incb X
.endm

.macro SPC_ADDR_ABS
    addl $2,%ebx
    movb 1(%esi),%al
    movw %bx,PC
    movb 2(%esi),%ah
    movl %eax,%ebx
.endm

.macro SPC_ADDR_OABS_XO
    addl $2,%ebx
    movb X,%al
    movw %bx,PC
    movb 1(%esi),%bl
    movb 2(%esi),%bh
    addl %eax,%ebx
    andl $0xFFFF,%ebx
.endm

.macro SPC_ADDR_OABS_YO
    addl $2,%ebx
    movb Y,%al
    movw %bx,PC
    movb 1(%esi),%bl
    movb 2(%esi),%bh
    addl %eax,%ebx
    andl $0xFFFF,%ebx
.endm

.macro SPC_ADDR_membit  // This is a weird addressing mode!
    xorl %edx,%edx
    addl $2,%ebx
    movb 2(%esi),%dl
    movw %bx,PC
    movb 1(%esi),%bl
    movb %dl,%bh
    andl $0x1FFF,%ebx   // Get address
    shrl $5,%edx        // Get bit number
.endm
